// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GEGLMM_PROCESSOR_H
#define _GEGLMM_PROCESSOR_H


#include <glibmm.h>

/* libgeglmm - a C++ wrapper for libgegl
 *
 * (c) 2008 Hubert Figuiere
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with GEGL; if not, see <http://www.gnu.org/licenses/>.
 */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GeglProcessor GeglProcessor;
typedef struct _GeglProcessorClass GeglProcessorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gegl
{ class Processor_Class; } // namespace Gegl
namespace Gegl
{

class Rectangle;
class Node;


class Processor
	: public Glib::Object
{
	
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Processor CppObjectType;
  typedef Processor_Class CppClassType;
  typedef GeglProcessor BaseObjectType;
  typedef GeglProcessorClass BaseClassType;

private:  friend class Processor_Class;
  static CppClassType processor_class_;

private:
  // noncopyable
  Processor(const Processor&);
  Processor& operator=(const Processor&);

protected:
  explicit Processor(const Glib::ConstructParams& construct_params);
  explicit Processor(GeglProcessor* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Processor();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GeglProcessor*       gobj()       { return reinterpret_cast<GeglProcessor*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GeglProcessor* gobj() const { return reinterpret_cast<GeglProcessor*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GeglProcessor* gobj_copy();

private:

public:
	Processor();

	
  void set_rectangle(const Rectangle & rectangle);;
	
  bool work(double & progress);;

//TODO: This "Frees up resources used by a processing handle", 
//but does it really destroy the whole GeglProcessor? If so, how does that work/clash with reference-counting.
//We should generally avoid having this in public C++ API.
	
  void destroy();
	#ifdef GLIBMM_PROPERTIES_ENABLED
/** The GeglNode to process (will saturate the provider's cache if the provided node is a sink node).
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_WriteOnly<  Glib::RefPtr<Gegl::Node> > property_node() ;
#endif //#GLIBMM_PROPERTIES_ENABLED


	#ifdef GLIBMM_PROPERTIES_ENABLED
/** Size of chunks being rendered (larger chunks need more memory to do the processing).
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< int> property_chunksize() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


	#ifdef GLIBMM_PROPERTIES_ENABLED
/** The rectangle of the region to process.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Gegl::Rectangle &> property_rectangle() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The rectangle of the region to process.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Gegl::Rectangle &> property_rectangle() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

	#ifdef GLIBMM_PROPERTIES_ENABLED
/** query progress; 0.0 is not started, 1.0 is done.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< double> property_progress() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** query progress; 0.0 is not started, 1.0 is done.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double> property_progress() const;
#endif //#GLIBMM_PROPERTIES_ENABLED
;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gegl::Processor
   */
  Glib::RefPtr<Gegl::Processor> wrap(GeglProcessor* object, bool take_copy = false);
}


#endif /* _GEGLMM_PROCESSOR_H */

